// HY_COMEXDlg.cpp : implementation file
//

#include "stdafx.h"
#include "HY_COMEX.h"
#include "HY_COMEXDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHY_COMEXDlg dialog

CHY_COMEXDlg::CHY_COMEXDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHY_COMEXDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CHY_COMEXDlg)
	m_bEcho = TRUE;
	//}}AFX_DATA_INIT
	m_RxLength=0;
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CHY_COMEXDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHY_COMEXDlg)
	DDX_Control(pDX, IDC_RX_LIST, m_RxList);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CHY_COMEXDlg, CDialog)
	//{{AFX_MSG_MAP(CHY_COMEXDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CLEAR_BT, OnClearBt)
	ON_BN_CLICKED(IDC_EXIT_BT, OnExitBt)
	ON_BN_CLICKED(IDC_SEND_BT, OnSendBt)
	ON_LBN_DBLCLK(IDC_RX_LIST, OnDblclkRxList)
	ON_BN_CLICKED(IDC_CHECK_ECHOMODE, OnCheckEchomode)
	ON_EN_CHANGE(IDC_TX_E, OnChangeTxE)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHY_COMEXDlg message handlers

BOOL CHY_COMEXDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	//add
	SetDlgItemText(IDC_TX_E,"STX01DRS,01,0001CRLF");
	m_bEcho=IsDlgButtonChecked(IDC_CHECK_ECHOMODE);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CHY_COMEXDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CHY_COMEXDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CHY_COMEXDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CHY_COMEXDlg::OnClearBt() 
{
	m_RxList.ResetContent();	
}

void CHY_COMEXDlg::OnExitBt() 
{
	OnOK();
}
//CCheckBox
void CHY_COMEXDlg::OnSendBt() 
{
	
    CString str;
	HANDLE  ComHandle;  
    DWORD	BytesRead[530] = {0x00,};
	DWORD	RxRead[530] = {0x00,};
	char	Tx_Buf[530] = {0x00,};
	//Non Echo .
	char	RxBuf[530] = {0x00,};
	//Echo Mode .
	char	RxBuf_Echo[530] = {0x00,};
	//temp buf l.s.c
	char RxTemp[530]={0x00,};

	int		iLenTx, iLenRx;
	int		Pos = 0;
	int		iSTX;
	int		iCR;
	int		iLF;

	int		Tj;
	int		Rj, Rk;
	char	ptr;
	char*	ptrSTX;	ptrSTX=NULL;//add
	char*	ptrCR; ptrCR=NULL;//add
	char*	ptrLF;ptrLF=NULL;//add
	char	TptrSTX[20];
	char	TptrCR[20];
	char	TptrLF[20];
	char	tempCom[530];
	char	COMDATA[530];

	char*	token; token=NULL;//add
	char	sSepX[] = "X";
	char	sSEpCRLF[] = "CRLF";

    ComHandle = Open_Comport();

    if (ComHandle == 0) 
	{
        MessageBox("Comport Open FAIL!\n");
        return;
    } 

	memset(&Tx_Buf,0, sizeof(Tx_Buf));
	memset(&RxBuf,0, sizeof(RxBuf));	// Get Stirng from Edit Box
	memset(&RxBuf_Echo,0, sizeof(RxBuf_Echo));
	memset(&RxTemp,0,sizeof(RxTemp));
	GetDlgItemText(IDC_TX_E, Tx_Buf, sizeof(Tx_Buf));
	iLenTx = strlen(Tx_Buf);

	token = strtok( Tx_Buf, sSepX );							// Get first token

	while( token != NULL )
	{
		token = strtok( NULL, sSepX );
		if (token != NULL)
			strcpy(tempCom ,token);
	}

	Pos = 3;

	for (Tj = 0; Tj < iLenTx; Tj++)
		COMDATA[Tj] = NULL;
	for (Tj = 0; Tj <= iLenTx - ((Pos+1)*2); Tj++)
	{
		COMDATA[Tj] = tempCom[Tj];
	}
	iSTX = 2;
	sprintf(TptrSTX, "%1c", iSTX);
	iCR = 13;
	sprintf(TptrCR, "%1c", iCR);
	iLF = 10;
	sprintf(TptrLF, "%1c", iLF);

	strcpy(tempCom, TptrSTX);
	strcat(tempCom, COMDATA);

	strcat(tempCom, TptrCR);

	strcat(tempCom, TptrLF);
	
	sprintf(Tx_Buf, tempCom);

	iLenTx = strlen(Tx_Buf);

    Write_Comport (ComHandle, iLenTx, Tx_Buf);

    Sleep (700);
	
	iLenRx=Read_Comport(ComHandle, BytesRead, sizeof(RxRead), RxRead);

	Rk = 0;
	strcpy(RxBuf_Echo, (char*)RxRead);
	


	Rj=0;

	if(m_bEcho){	
		for (int Rj = 0; Rj < iLenRx; Rj++){// ٲٱ..
			RxBuf[Rj] = RxBuf_Echo[Rj+iLenTx];//loop frame +time delay  response frame 
		}//for
	}
	else {
		 strcpy(RxBuf,RxBuf_Echo);
	}

//error ó ߰.
	if(m_bEcho){	
		if (iLenRx == iLenTx )
		{
			//L.S.C error ("No Response");
			str.Format("No Response %d",iLenRx);
			m_RxList.AddString(str);
			Close_Comport(ComHandle);
			return;
		}
		else{		
			if (RxBuf[0] != 0x02)
			{
				str.Format("Result data is Wrong Form");
				Close_Comport(ComHandle);
				m_RxList.AddString(str);
				return;
				
			}
		}
	}
	//L.S.C	
	if(iLenRx == 0){
		str.Format("Communication Fail %d",iLenRx);
		Close_Comport(ComHandle);
		m_RxList.AddString(str);		
	}

	for (Rj = 0; Rj < iLenRx; Rj++)
	{
		ptr = RxBuf[Rj];
		COMDATA[Rj] = 0x00;
		
		if (ptr == 0xFF)
		{
			iLenRx = iLenRx-1;
		}

		if (ptr == 0x02)
		{		
			ptrSTX = "STX";	
			
		}
		else if (ptr == 0x0D)
		{
			ptrCR = "CR";
		}
		else if (ptr == 0x0A)
		{
			ptrLF = "LF";
		}
		else
		{
			COMDATA[Rk] = ptr; 
			Rk++;
		}
	}


	strcpy(RxBuf,ptrSTX);
	strcat(RxBuf, COMDATA);
	strcat(RxBuf, "CR");
	strcat(RxBuf, "LF");
	m_RxList.AddString(RxBuf);
    Close_Comport(ComHandle);
}
//  ι..
#define XON		0x11
#define XOFF	0x13
HANDLE	CHY_COMEXDlg::Open_Comport()
{
	HANDLE	DriverHandle;
	char	sCom_Name[10];
	DCB		My_DCB;
	COMMTIMEOUTS CommTimeOuts;
	sprintf(sCom_Name, "COM1");

    DriverHandle = CreateFile (sCom_Name, GENERIC_READ | GENERIC_WRITE,
                                0, NULL, OPEN_EXISTING, 0, NULL);

    if (DriverHandle == INVALID_HANDLE_VALUE) 
	        return (DriverHandle);
    else
	{

		SetupComm (DriverHandle, 1024, 1024);

		//add lifesay
		///*
		CommTimeOuts.ReadIntervalTimeout = 50;//500 -> 0xFFFFFFFF msec;
		CommTimeOuts.ReadTotalTimeoutMultiplier = 0;
		CommTimeOuts.ReadTotalTimeoutConstant = 0;
		CommTimeOuts.WriteTotalTimeoutMultiplier = 0;
		CommTimeOuts.WriteTotalTimeoutConstant =1000 ;//5000
		SetCommTimeouts(DriverHandle, &CommTimeOuts);
		//*/
		
		//////////////////////////////////////////////////////////////////////////
		
		GetCommState (DriverHandle, &My_DCB);

		My_DCB.BaudRate = CBR_9600;
		My_DCB.fParity = 0;
		My_DCB.fOutxCtsFlow = 0;
		My_DCB.fOutxDsrFlow = 0;
		My_DCB.fDtrControl = DTR_CONTROL_ENABLE;
		My_DCB.fDsrSensitivity = FALSE;
		My_DCB.fTXContinueOnXoff = 0;
		My_DCB.fOutX = 0;
		My_DCB.fInX = 0;
		My_DCB.fErrorChar = 0;
		My_DCB.fNull = FALSE;
		My_DCB.fRtsControl = RTS_CONTROL_DISABLE;
		My_DCB.fAbortOnError = 0;

		//L.S.C
		My_DCB.XonChar=XON;//߰..
		My_DCB.XoffChar=XOFF;//߰.

		My_DCB.ByteSize = 8;
		My_DCB.Parity = NOPARITY;
		My_DCB.StopBits = ONESTOPBIT;

		SetCommState (DriverHandle, &My_DCB); 

		SetCommMask (DriverHandle, EV_TXEMPTY );
    }

	return DriverHandle;
}

int	CHY_COMEXDlg::Close_Comport (HANDLE DriverHandle)
{
    if ((DriverHandle == 0) || (DriverHandle == INVALID_HANDLE_VALUE)) {
        return FALSE;
    }

    CloseHandle (DriverHandle);

    return TRUE;
}

int	CHY_COMEXDlg::Write_Comport (HANDLE DriverHandle, DWORD NumBytes, void *Buffer)
{
    DWORD EvtMask, BytesWritten;
    BOOL status;
	//add lifesay
	PurgeComm(DriverHandle,PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);//Ʈ ..

    if ((DriverHandle == 0) || (DriverHandle == INVALID_HANDLE_VALUE)) {
        return FALSE;
    } 

    EscapeCommFunction (DriverHandle, SETRTS);
	Sleep(0);
    status = WriteFile (DriverHandle, Buffer, NumBytes, &BytesWritten, 0);
	Sleep(0);
    WaitCommEvent(DriverHandle, &EvtMask, NULL);

    EscapeCommFunction (DriverHandle, CLRRTS);
 
    return TRUE;
}

int CHY_COMEXDlg::Read_Comport (HANDLE DriverHandle, DWORD *BytesRead, DWORD BufferSize, void *Buffer)
{
    COMSTAT     Our_Comstat;
    DWORD       Com_Errors, BytesToRead;

    if ((DriverHandle == 0) || (DriverHandle == INVALID_HANDLE_VALUE)) {
        return FALSE;
    } 

    ClearCommError (DriverHandle, &Com_Errors, &Our_Comstat);

    if (Our_Comstat.cbInQue > 0) {

    if (Our_Comstat.cbInQue > BufferSize) {
            BytesToRead = BufferSize;
    } else {
        BytesToRead = Our_Comstat.cbInQue;
    }

    ReadFile (DriverHandle, Buffer, BytesToRead, BytesRead, NULL);

    } else {
        *BytesRead = 0;
    }

	return BytesToRead;
}

void CHY_COMEXDlg::OnDblclkRxList() 
{
	char sTempList[530];
	int	 iTempList;

	iTempList = m_RxList.GetCurSel();
	m_RxList.GetText(iTempList, sTempList); 

	MessageBox(sTempList, "Read Data", MB_OK);
}

BOOL CHY_COMEXDlg::PreTranslateMessage(MSG* pMsg) 
{
	if (pMsg->message == WM_KEYDOWN)    
    {
        if(pMsg->wParam == VK_RETURN)
            return FALSE;
    }
    return CDialog::PreTranslateMessage(pMsg);
}


void CHY_COMEXDlg::OnCheckEchomode() 
{
	// TODO: Add your control notification handler code here
	//l.s.c
	m_bEcho=IsDlgButtonChecked(IDC_CHECK_ECHOMODE);//TRUE

}

void CHY_COMEXDlg::OnChangeTxE() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	
}
